package sample.controller.samplecairngorm.command
{
	import com.adobe.cairngorm.commands.ICommand;
	import com.adobe.cairngorm.control.CairngormEvent;
	
	import mx.rpc.IResponder;
	
	import sample.controller.samplecairngorm.event.ClickBtnHelloWorldEvent;
	import sample.datamodel.ApplicationDataModel;
	import sample.service.samplecairngorm.SamplecairngormHttpDelegate;

	/**
	 * イベントを実際に実行するコマンドクラスです
	 */
	public class ClickBtnHelloWorldCommand implements ICommand,IResponder
	{
		/**
		 * イベント発生後、最初に実行されるメソッドです。<br>
		 * @param event CairngormEvent
		 */
		public function execute(event:CairngormEvent):void
		{
			// イベントはCairngormイベントの形でわたってきますので、
			// それを専用のイベントにキャストします。
			var e:ClickBtnHelloWorldEvent = event as ClickBtnHelloWorldEvent;
			// Delegateクラスをインスタンス化する際に自分のインスタンスを渡します。
			// これは「IResponder」インターフェースを実装したクラスが自分だからです。
			var httpDelegate:SamplecairngormHttpDelegate = new SamplecairngormHttpDelegate(this);
			// Delegateをインスタンス化する際に自分のインスタンスを渡していますが、
			// このことにより、下記、メソッドが実行され、HTTPServiceあるいはRemoteObjectでの
			// サーバー連携の結果が自分のインスタンスの「result」あるいは「fault」メソッドに
			// 帰ってくるようになります。
			httpDelegate.clickBtnHelloWorld(new Object());
		}
		/**
		 * Resultイベントハンドラです。<br>
		 * @param data オブジェクト
		 */
		public function result(data:Object):void
		{
			var model:ApplicationDataModel = ApplicationDataModel.getInstance();
			model.sampleModel.txtField = data.result.docs.doc.say;
		}
		/**
		 * Faultイベントハンドラです。<br>
		 * @param info オブジェクト
		 */
		public function fault(info:Object):void
		{
			
		}
	}
}