package sample.service.samplecairngorm
{
	import mx.rpc.IResponder;
	import mx.rpc.http.HTTPService;
	import com.adobe.cairngorm.business.ServiceLocator;
	
	import sample.service.ApplicationService;
	
	/**
	 * サーバと連携するためのクラスです。
	 */
	public class SamplecairngormHttpDelegate
	{
		private var _responder:IResponder;
		private var _httpService:HTTPService;
		
		/**
		 * コンストラクタです。
		 * @param callingCommand サービス実行結果を返却する先を示すオブジェクトIResponderです。
		 */
		public function SamplecairngormHttpDelegate(callingCommand:IResponder)
		{
			// ApplicationServicecからHTTPServiceのインスタンスを取得します。
			_httpService = ServiceLocator.getInstance().getHTTPService(ApplicationService.APPLICATION_HTTP_SERVICE_NAME);
			// 返却オブジェクトを保持します。
			_responder = callingCommand;
		}
		/**
		 * Commandクラスから呼び出されるサーバ連携用メソッドです。
		 * @param o サーバーに渡したい値などを入れたObjectクラスです。
		 */
		public function clickBtnHelloWorld(o:Object):void
		{
			// 返却オブジェクトのTOKENを指定するため、一時的にObject型に変換しています。
			var service:Object			= _httpService;
			// URLを指定します。
			_httpService.url = "./hello.xml";
			// アクセスした結果をserviceに返却し、そのserviceのresultHandlerとfaultHandlerのtokenに設定します。
			service						= _httpService.send();
			service.resultHandler		= _responder.result;
			service.faultHandler		= _responder.fault;
		}

		
	}
}